import paho.mqtt.client as PahoMQTT
import json

def config_extract():
	configurations = {}
	"""Open and extract all the MQTT config"""
	try:
		with open(confFilename, 'r') as f:
			configurations = json.load(f)
	except FileNotFoundError as e:
		raise(e)

		return configurations


class Publisher(object):
	"""docstring for Client"""
	def __init__(self, configFile,name):
		f_conf=open(configFile)
		init_conf=json.load(f_conf)
		f_conf.close()
		self._paho_mqtt=PahoMQTT.Client(name,False)
		self._paho_mqtt.on_connect=self.OnConnect
		#self.topic=init_conf["mqtt"]["topic"]
		self.broker=init_conf["mqtt"]["brokerID"]
		self.port=init_conf["mqtt"]["brokerPort"]
		self.qos=init_conf["mqtt"]["QoS"]
		
	def start(self):
		self._paho_mqtt.connect(self.broker, self.port)
		self._paho_mqtt.loop_start()

	def OnConnect(self, paho_mqtt, userData, flags, rc):
		print("Publisher connected to {} with result {}".format(self.broker,rc))
		#logging.info("Publisher connected to {} with result {}".format(self.broker,rc))

	
	def Publish(self, topicID, data):		
		self._paho_mqtt.publish(topicID, data, self.qos)   #### data=> dictionary "value": int|float|string
		#logging.info("Published new topic {}".format(topicID))
		#logging.debug("Topic: {}\tpayload: {}".format(topicID, data))
		#print("Published new topic {}".format(topicID))
		print("Topic: {}\tpayload: {}".format(topicID, data))
	
	def stop(self):
		self._paho_mqtt.loop_stop()
		self._paho_mqtt.disconnect()

if __name__ == '__main__':

	pub = Publisher("MQTT-conf.json","NVT3-pub")

	while True:
		topic = input("Insert topic > ")
		data = input("Insert data > ")

		pub.Publish(topic,data)


